/*
   IMPORTANT: Try compiling this example using the
              online compiler and disassembler at:

              http://gcc.godbolt.org


DS_t f(...);         // DS_t automatically allocated in caller's local space
     f(DS_t x, ...); // DS_t automatically allocated in callee's local space
*/
#include <stdio.h>
#include <stdlib.h>


typedef struct DS_t {
   int a;
   double b;
   char c;
} DS_t;


DS_t f5(int n)  /* DS_t automatically allocated in caller's local space */
{
   DS_t x;
   x.a = n;
   return x;
}


void f6(DS_t x)  /* DS_t automatically allocated in callee's local space */
{
   printf("in f6(), x.a = %d\n", x.a);
}


int main()
{
   DS_t ds5 = f5(50); /* return value from f5() is copied into ds5 */
   printf("in main(), ds5.a = %d\n", ds5.a);

   DS_t ds6;
   ds6.a = 60;
   f6(ds6); /* ds6 is copied into f6's actual parameter */

   return 0;
}
