/*
   This program defines a function add() that
   takes a "variable number of arguments".

   https://www.cplusplus.com/reference/cstdarg/
   https://en.cppreference.com/w/c/variadic
   https://www.geeksforgeeks.org/variadic-functions-in-c/
   https://en.wikipedia.org/wiki/Variadic_function#In_C
*/
#include <stdarg.h>
#include <stdio.h>

int add(int x, ...)
{
   int sum = 0;

   // Declaring a pointer to the argument list.
   va_list ptr;

   // Initializing the pointer.
   va_start(ptr, x);

   for (int i = 0; i < x; ++i)
   {
      // Accessing current argument and pointing to next one.
      sum += va_arg(ptr, int);
   }
   // Ending argument list traversal.
   va_end(ptr);

   return sum;
}

int main() {
   printf("%d\n", add(1, 1) );
   printf("%d\n", add(2, 1, 2) );
   printf("%d\n", add(3, 1, 2, 3) );
   printf("%d\n", add(4, 1, 2, 3, 4) );
   printf("%d\n", add(5, 1, 2, 3, 4, 5) );
   printf("%d\n", add(6, 1, 2, 3, 4, 5, 6) );
   printf("%d\n", add(7, 1, 2, 3, 4, 5, 6, 7) );
   return 0;
}
