/*
   This program defines a function add() that
   takes a "variable number of arguments".

   https://www.cplusplus.com/reference/cstdarg/
   https://en.cppreference.com/w/c/variadic
   https://www.geeksforgeeks.org/variadic-functions-in-c/
   https://en.wikipedia.org/wiki/Variadic_function#In_C
*/
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

char* concat(char c1, char c2, int n, ...)
{
   char * str = malloc(n + 3);
   str[0] = c1;
   str[n+1] = c2;
   str[n+2] = '\0';

   // Declaring a pointer to the argument list.
   va_list ptr;

   // Initializing the pointer.
   va_start(ptr, n);

   for (int i = 1; i < n + 1; ++i)
   {
      // Accessing current argument and pointing to next one.
      str[i] = va_arg(ptr, int);
   }
   // Ending argument list traversal.
   va_end(ptr);

   return str;
}

int main() {
   printf("%s\n", concat('[', ']', 3, 'a', 'b', 'c') );
   printf("%s\n", concat('(', ')', 5, 'x', ' ', 'y', ' ', 'z') );
   printf("%s\n", concat('"', '"', 3, 'd', 'o', 'g') );
   printf("%s\n", concat('<', '>', 6, 'a', 'p', 'p', 'l', 'e', 's') );
   return 0;
}
